C
C     GSX-80 DRIVER for Metafile
C     Copyright (C) 2014 by Udo Munk
C     Copyright (C) 2020 by Martin Hepperle
C

C234567890123456789012345678901234567890123456789012345678901234567890123456789
C----vv----------------------------------------------------------------v-------
      SUBROUTINE DDMF(CONTRL,INTIN,PTSIN,INTOUT,PTSOUT)
      INTEGER CONTRL(1),INTIN(1),PTSIN(1),INTOUT(1),PTSOUT(1)
C
C     VARIABLES
C
      INTEGER I,J,K
      INTEGER OPCODE,INMODE
      LOGICAL PFLAG,OFLAG
      INTEGER PMSC,CANG,CHGT,LNTP,LNWD,MKTP
      INTEGER XY(2)
      INTEGER XLO,YLO,XHI,YHI
      INTEGER*1 LINE(10)
      INTEGER ZERO,ONE,THREE,FOUR
      INTEGER CLAMP
      EXTERNAL CLAMP
C
C     DATA
C
C     PRINT FLAG FOR DRIVER COPYRIGHT AND VERSION TEXT
      DATA PFLAG /.FALSE./
C     WORKSTATION OPEN FLAG
      DATA OFLAG /.FALSE./
      DATA ZERO,ONE,THREE,FOUR /0,1,3,4/
C
C     INITIALIZATION
C
      CONTRL(3) = 0
      CONTRL(5) = 0

      OPCODE = CONTRL(1)

C     DONT DRAW ON CLOSED WOKSTATION
      IF (OFLAG .NE. .TRUE. .AND. OPCODE .NE. 1) RETURN


C
C     DISPATCH ON OPCODE
C
      GOTO(1100,1200,1300,1400,1500,1600,1700,1800,1900,2000,
     1     2100,2200,2300,2400,2500,2600,2700,2800,2900,3000,
     2     3100,3200,3300,3400,3500,3600,3700,3800,3900,4000,
     3     4100,4200,4300),OPCODE
      RETURN

C
C     OPCODE OPEN WORKSTATION
C
1100  IF (PFLAG .NE. .FALSE.) GOTO 1110
      CALL MFPRTV
      PFLAG = .TRUE.

1110  CONTRL(3) = 6
      CONTRL(5) = 45
      LNTP = CLAMP(INTIN(2),1,9)
      MKTP = CLAMP(INTIN(4),1,6)
      CHHT = 2*327
      CANG = 0
      PMSC = 2*327

      INTOUT(1) = 23170
      INTOUT(2) = 32766
      INTOUT(3) = 0
      INTOUT(4) = 9
      INTOUT(5) = 9
      INTOUT(6) = 0
      INTOUT(7) = 6
      INTOUT(8) = 1
      INTOUT(9) = 5
      INTOUT(10) = 1
      INTOUT(11) = 1
      INTOUT(12) = 0
      INTOUT(13) = 0
      INTOUT(14) = 256
      INTOUT(15) = 0
      INTOUT(16) = -1
      INTOUT(17) = -1
      INTOUT(18) = -1
      INTOUT(19) = -1
      INTOUT(20) = -1
      INTOUT(21) = -1
      INTOUT(22) = -1
      INTOUT(23) = -1
      INTOUT(24) = -1
      INTOUT(25) = -1
      INTOUT(26) = -1
      INTOUT(27) = -1
      INTOUT(28) = -1
      INTOUT(29) = -1
      INTOUT(30) = -1
      INTOUT(31) = -1
      INTOUT(32) = -1
      INTOUT(33) = -1
      INTOUT(34) = -1
      INTOUT(35) = -1
      INTOUT(36) = 1
      INTOUT(37) = 1
      INTOUT(38) = 1
      INTOUT(39) = 0
      INTOUT(40) = 256
      INTOUT(41) = 0
      INTOUT(42) = 0
      INTOUT(43) = 0
      INTOUT(44) = 0
C     Metafile
      INTOUT(45) = 4
      PTSOUT(1) = 0
C     min char height = 1%
      PTSOUT(2) = 327
      PTSOUT(3) = 0
C     max char height = 50%
      PTSOUT(4) = 16384
      PTSOUT(5) = 50
      PTSOUT(6) = 0
      PTSOUT(7) = 5000
      PTSOUT(8) = 0
      PTSOUT(9) = 0
C     min marker size 1%
      PTSOUT(10) = 327
      PTSOUT(11) = 0
      PTSOUT(12) = 16384
      OFLAG = .TRUE.

      CALL MFOPEN

      GOTO 1300
C      RETURN

C
C     OPCODE CLOSE WORKSTATION
C
1200  CONTINUE
      OFLAG = .FALSE.
      CALL MFCLOS
      RETURN

C
C     OPCODE CLEAR WORKSTATION
C
C     clear grapics
1300  CONTINUE
      RETURN

C
C     OPCODE UPDATE WORKSTATION
C
1400  CONTINUE
      RETURN
C
C     OPCODE ESCAPE
C
1500  OPCODE = CONTRL(6)
C     DISPATCH ON FUNCTION
      GOTO(1501,1502,1503,1504,1505,1506,1507,1508,1509,1510,
     1     1511,1512,1513,1514),OPCODE
      RETURN
C     INQUIRE ADDRESSABLE CHARACTER CELLS
1501  INTOUT(1) = 24
      INTOUT(2) = 80
      RETURN

C     ENTER GRAPHICS MODE
1502  CONTINUE
      RETURN

C     EXIT GRAPHICS MODE
1503  CONTINUE
      RETURN

C     CURSOR UP     Ctrl+A
1504  CONTINUE
      RETURN
C     CURSOR DOWN   Ctrl+B
1505  CONTINUE
      RETURN
C     CURSOR RIGHT  Ctrl+C
1506  CONTINUE
      RETURN
C     CURSOR LEFT   Ctrl+D
1507  CONTINUE
      RETURN
C     HOME CURSOR
1508  CONTINUE
      RETURN
C     ERASE TO END OF SCREEN
1509  CONTINUE
      RETURN
C     ERASE TO END OF LINE
1510  CONTINUE
      RETURN

C     DIRECT CURSOR ADDRESS
C     Esc & a 12 r 04 C == row and column
1511  CONTINUE
      I = CLAMP(INTIN(1),1,24)
      J = CLAMP(INTIN(2),1,80)
      RETURN

C     OUTPUT CURSOR ADDRESSABLE TEXT
1512  CONTINUE
      RETURN

C     REVERSE VIDEO ON
C     Esc & d B == inverse
1513  CONTINUE
      RETURN

C     REVERSE VIDEO OFF
1514  CONTINUE
      RETURN

C
C     OPCODE POLYLINE
C
1600  CONTINUE
      CALL MFREC (OPCODE,CONTRL(2),ZERO,PTSIN,INTIN)
      RETURN

C
C     OPCODE POLYMARKER
C
1700  CONTINUE
      CALL MFREC(OPCODE,CONTRL(2),ZERO,PTSIN,INTIN)
      RETURN

C
C     OPCODE TEXT
C
1800  CONTINUE
      CALL MFREC(OPCODE,CONTRL(2),CONTRL(4),PTSIN,INTIN)
      RETURN


C
C     OPCODE FILLED AREA
C
1900  CONTINUE
      CALL MFREC(OPCODE,CONTRL(2),ZERO,PTSIN,INTIN)
      RETURN

C
C     OPCODE CELL ARRAY
C
2000  CONTINUE
      XLO = PTSIN(1)
      XHI = PTSIN(2)
      XHI = PTSIN(3)
      YHI = PTSIN(4)
      RETURN

C
C     OPCODE GENERALZED DRAWING PRIMITIVE
C
2100  RETURN

C
C     OPCODE SET CHARACTER HEIGHT
C
2200  CONTINUE
      CHGT = CLAMP(PTSIN(2),327,16384)
C     adapt character height
      PTSIN(2) = CHGT + CHGT/4

      CALL MFREC(OPCODE,CONTRL(2),ZERO,PTSIN,INTIN)

      CONTRL(3) = 2
C      PTSOUT(1) = CHRWID(J)
C      PTSOUT(2) = CHRHGT(J)
C      PTSOUT(3) = CELWID(J)
C      PTSOUT(4) = CELHGT(J)
C     avoid overflow
      PTSOUT(1) = CHGT/5*4
      PTSOUT(2) = CHGT
      PTSOUT(3) = CHGT/5*4
      PTSOUT(4) = CHGT/5*7
      RETURN

C
C     OPCODE SET CHARACTER UP VECTOR   [0...3600]
C
2300  CONTINUE
      CANG = INTIN(1)
      CALL MFREC(OPCODE,ZERO,THREE,PTSIN,INTIN)
      INTOUT(1) = CANG
      RETURN

C
C     OPCODE SET COLOR REPRESENTATION
C
2400  CONTINUE
      CALL MFREC(OPCODE,ZERO,FOUR,PTSIN,INTIN)
      RETURN

C
C     OPCODE SET POLYLINE LINETYPE
C
2500  LNTP = CLAMP(INTIN(1),1,6)
      INTIN(1) = LNTP
      CALL MFREC(OPCODE,ZERO,ONE,PTSIN,INTIN)
      INTOUT(1) = LNTP
      RETURN

C
C     OPCODE SET POLYLINE WIDTH
C
2600  LNWD = CLAMP(INTIN(1),50,5000)
      INTIN(1) = LNWD
      CALL MFREC(OPCODE,ONE,ZERO,PTSIN,INTIN)
      CONTRL(3) = 1
      PTSOUT(1) = LNWD
      PTSOUT(2) = 0
      RETURN

C
C     OPCODE SET POLYLINE COLOR INDEX
C
2700  INTOUT(1) = 1
      CALL MFREC(OPCODE,ZERO,ONE,PTSIN,INTIN)
      RETURN

C
C     OPCODE SET POLYMARKER TYPE
C
2800  MKTP = CLAMP(INTIN(1),1,6)
      INTIN(1) = MKTP
      CALL MFREC(OPCODE,ZERO,ONE,PTSIN,INTIN)
      INTOUT(1) = MKTP
      RETURN

C
C     OPCODE SET POLYMARKER SCALE
C
2900  PMSC = CLAMP(PTSIN(2),327,16384)
      PTSIN(2) = PMSC
      CALL MFREC(OPCODE,ONE,ZERO,PTSIN,INTIN)
      CONTRL(3) = 1
      PTSOUT(1) = 0
      PTSOUT(2) = PMSC
      RETURN

C
C     OPCODE SET POLYMARKER COLOR INDEX
C
3000  INTOUT(1) = INTIN(1)
      CALL MFREC(OPCODE,ZERO,ONE,PTSIN,INTIN)
      RETURN

C
C     OPCODE SET TEXT FONT
C
3100  INTOUT(1) = INTIN(1)
      CALL MFREC(OPCODE,ZERO,ONE,PTSIN,INTIN)
      RETURN

C
C     OPCODE SET TEXT COLOR INDEX
C
3200  INTOUT(1) = INTIN(1)
      CALL MFREC(OPCODE,ZERO,ONE,PTSIN,INTIN)
      RETURN

C
C     OPCODE SET FILL INTERIOR STYLE
C
3300  INTOUT(1) = INTIN(1)
      CALL MFREC(OPCODE,ZERO,ONE,PTSIN,INTIN)
      RETURN

C
C     OPCODE SET FILL STYLE INDEX
C
3400  INTOUT(1) = INTIN(1)
      CALL MFREC(OPCODE,ZERO,ONE,PTSIN,INTIN)
      RETURN

C
C     OPCODE SET FILL COLOR INDEX
C
3500  INTOUT(1) = 1
      RETURN

C
C     OPCODE INQUIRE COLOR REPRESENTATION
C
3600  INTOUT(1) = INTIN(1)
      INTOUT(2) = 0
      INTOUT(3) = 0
      INTOUT(4) = 0
      RETURN

C
C     OPCODE INQUIRE CELL ARRAY
C
3700  CONTRL(8) = 0
      CONTRL(9) = 0
      CONTRL(10) = 1
      RETURN

C
C     OPCODE INPUT LOCATOR
C
3800  CONTINUE
      CONTRL(5) = 1
      CONTRL(3) = 1
      PTSOUT(1) = 0
      PTSOUT(2) = 0
      INTOUT(1) = 0
      RETURN

C
C     OPCODE INPUT VALUATOR
C
3900  CONTRL(5) = 0
      RETURN

C
C     OPCODE INPUT CHOICE
C
4000  CONTRL(5) = 0
      RETURN

C
C     OPCODE INPUT STRING
C
4100  RETURN

C
C     OPCODE SET WRITING MODE
C
4200  INTOUT(1) = 2
      RETURN

C
C     OPCODE SET INPUT MODE
C
4300  INMODE = INTIN(2)
      INTOUT(1) = INMODE
      RETURN

      END

C
C     Limit I to the range LO...HI
C
      INTEGER FUNCTION CLAMP( I, LO, HI )
      INTEGER I, LO, HI

      IF ( I .LT. LO ) GOTO 100
      IF ( I .GT. HI ) GOTO 200

      CLAMP = I
      RETURN

100   CLAMP = LO
      RETURN

200   CLAMP = HI
      RETURN

      END

C
C     Output a Metafile record with optional data arrays
C
      SUBROUTINE MFREC(OPCODE,NPTS,NINT,PTSIN,INTIN)
      INTEGER OPCODE,NPTS,NINT
      INTEGER PTSIN(255),INTIN(255)

C     Record header
      CALL MFINT(OPCODE)
      CALL MFINT(NPTS)
      CALL MFINT(NINT)
      CALL MFINT(0)

C     Record data (if any)

      IF ( NPTS .EQ. 0 ) GOTO 101
      N = NPTS*2
      DO 100 I=1,N
        CALL MFINT(PTSIN(I))
100   CONTINUE

101   CONTINUE
      IF ( NINT .EQ. 0 ) GOTO 201
      DO 200 I=1,NINT
        CALL MFINT(INTIN(I))
200   CONTINUE

201   CONTINUE

      RETURN
      END
